#include <HX711.h>
//Pour ajouter la librairie : Outils - Gérer les bibliothèques - Rechercher HX711 - Installer


HX711 capteur;
int DAT = 3;                //Pin Data du capteur connectée à la pin 3 du microcontroleur
int CLK = 2;                //Pin Data du capteur connectée à la pin 3 du microcontroleur
long valeur;                //Valeur de la masse codée sur 21 bits (0-5 kg > 420 par gramme)
int conversion = 420;       //Calibration du capteur, coeficient de proportionnalité entre la masse et la valeur retournée par le capteur
const int lockPin = 13;     //Pin de commande du verrou
boolean lockState;          //Etat du verrou en fonction de la masse deposee

//*** Variable a modifier par l'utilisateur ***
int massTarget = 105;       //Masse recherchee en grammes
int massAccuracy = 5;       //Tolerance sur la masse mesuree en grammes (minimum 5 g compte-tenu de la précision du capteur
int delai = 3000;           //Lecture du capteur toutes les x ms.
//********************************************* 

void setup() {
  capteur.begin(DAT, CLK);
  pinMode(lockPin, OUTPUT);
  Serial.begin(9600);
  while (!Serial) {
  }
  Serial.println("HX711");
  // tarage du capteur
  // lorsque le microcontroleur est mis sous tension, il effectue la tare du capteur. Il faut donc y placer les eventuels supports avant de connecter l'alimentation.
  Serial.println("Tarage du capteur");
  Serial.println("Le capteur doit etre fixe et ne pas etre touche ou deplace");
  capteur.tare();
}

void loop() {
  valeur = capteur.get_value(10); //Valeur moyenne sur x ms.
  Serial.print("Valeur mesuree (avec tare) : ");
  Serial.println(valeur);

  //Compare la masse mesuree a la consigne 
  if((valeur/conversion) > (massTarget-massAccuracy) && (valeur/conversion) < (massTarget+massAccuracy)) {
    lockState = HIGH;
  } else {lockState = LOW;
  }
  //*************************************
  
  digitalWrite(lockPin,lockState);
   
  //Affichage de l'etat de lockPin
    Serial.print("Le pin n°");
    Serial.print(lockPin);
    Serial.print(" est ");
      if(lockState) {
        Serial.print("HIGH");
      } else { Serial.print("LOW");
      }
  //**************************
      
  delay(delai); 
}
